TLM-2.0: tlm::tlm_array< T > Class Template Reference

# tlm::tlm_array< T > Class Template Reference

`#include <tlm_array.h>`

Collaboration diagram for tlm::tlm_array< T >:

[legend]

List of all members.

## Public Member Functions
| tlm_array (unsigned int size=0, T default_value=0)
| tlm_array (const tlm_array &orig)
| ~tlm_array ()
T & | operator[] (const unsigned int index)
const T & | operator[] (const unsigned int index) const
unsigned int | size () const
void | expand (unsigned int new_size)
const char * | kind () const
void | insert_in_cache (T *p)
void | free_entire_cache ()
## Static Public Attributes
static const char *const | kind_string = "tlm_array"
## Protected Member Functions
tlm_array & | operator= (const tlm_array< T > &)
void | report_error (std::exception &e)
## Protected Attributes
T * | m_data
unsigned int | m_size
T ** | m_entries
unsigned int | m_last_entry
T | m_default

## Detailed Description

### template<typename T>
class tlm::tlm_array< T >

Definition at line 49 of file tlm_array.h.

## Constructor & Destructor Documentation

template<typename T>

tlm::tlm_array< T >::tlm_array | ( | unsigned int | size = `0`,
|  | T | default_value = `0` |
| ) |  |  | `[inline]`

Definition at line 54 of file tlm_array.h.

template<typename T>

tlm::tlm_array< T >::tlm_array | ( | const tlm_array< T > & | orig | ) | `[inline]`

Definition at line 65 of file tlm_array.h.

template<typename T>

tlm::tlm_array< T >::~tlm_array | ( |  | ) | `[inline]`

Definition at line 92 of file tlm_array.h.

## Member Function Documentation

template<typename T>

void tlm::tlm_array< T >::expand | ( | unsigned int | new_size | ) | `[inline]`

Definition at line 114 of file tlm_array.h.

template<typename T>

void tlm::tlm_array< T >::free_entire_cache | ( |  | ) | `[inline]`

Definition at line 203 of file tlm_array.h.

template<typename T>

void tlm::tlm_array< T >::insert_in_cache | ( | T * | p | ) | `[inline]`

Definition at line 197 of file tlm_array.h.

template<typename T>

const char* tlm::tlm_array< T >::kind | ( |  | ) | const`[inline]`

Definition at line 193 of file tlm_array.h.

template<typename T>

tlm_array& tlm::tlm_array< T >::operator= | ( | const tlm_array< T > & |  | ) | `[protected]`

template<typename T>

const T& tlm::tlm_array< T >::operator[] | ( | const unsigned int | index | ) | const`[inline]`

Definition at line 104 of file tlm_array.h.

template<typename T>

T& tlm::tlm_array< T >::operator[] | ( | const unsigned int | index | ) | `[inline]`

Definition at line 99 of file tlm_array.h.

template<typename T>

void tlm::tlm_array< T >::report_error | ( | std::exception & | e | ) | `[inline, protected]`

Definition at line 227 of file tlm_array.h.

template<typename T>

unsigned int tlm::tlm_array< T >::size | ( |  | ) | const`[inline]`

Definition at line 111 of file tlm_array.h.

## Member Data Documentation

template<typename T>

const char *const tlm::tlm_array< T >::kind_string = "tlm_array"`[inline, static]`

Definition at line 192 of file tlm_array.h.

template<typename T>

T* tlm::tlm_array< T >::m_data`[protected]`

Definition at line 215 of file tlm_array.h.

template<typename T>

T tlm::tlm_array< T >::m_default`[protected]`

Definition at line 221 of file tlm_array.h.

template<typename T>

T** tlm::tlm_array< T >::m_entries`[protected]`

Definition at line 218 of file tlm_array.h.

template<typename T>

unsigned int tlm::tlm_array< T >::m_last_entry`[protected]`

Definition at line 219 of file tlm_array.h.

template<typename T>

unsigned int tlm::tlm_array< T >::m_size`[protected]`

Definition at line 216 of file tlm_array.h.

The documentation for this class was generated from the following file:

- include/tlm/tlm_h/tlm_generic_payload/tlm_array.h